program SortLst;

uses
	SortList,
	SysUtils;

type
	TMyList=class(TSortList)
		public
		a,b,c:integer;
		n:double;
		_:byte;
		end;

var
	MyList:TMyList;
	a,Del,Count:integer;
	Time1:TDateTime;
	h,m,s,s1:word;

begin
MyList:=TMyList.Create;
with MyList do Define(_,_);
Write('Number of records to test with ? ');ReadLn(Count);
Write('Creating ...');
Time1:=Time;
for a:=1 to Count do
	begin
	MyList.Append;
	MyList.a:=a;
	MyList.b:=a*2;
	MyList.c:=a*3;
	MyList.n:=a*0.12;
	MyList.Post;
	end;
Time1:=Time-Time1;
DecodeTime(Time1,h,m,s,s1);
Writeln(' Time = ',h,':',m,':',s,'.',s1);
Write('Deleting every 2nd ... ');
Time1:=Time;
MyList.First;
if not MyList.EOF then
	for a:=1 to MyList.RecordCount do
		if a mod 2=0 then MyList.Delete else MyList.Next;
Time1:=Time-Time1;
DecodeTime(Time1,h,m,s,s1);
Writeln(' Time = ',h,':',m,':',s,'.',s1);
Write('Searching + creating if not found ... ');
Del:=0;
Time1:=Time;
MyList.First;
for a:=1 to Count do
	if not MyList.FindKey([a,a*2,a*3,a*0.12]) then
		begin
		Inc(Del);
		MyList.Append;
		MyList.a:=a;
		MyList.b:=a*2;
		MyList.c:=a*3;
		MyList.n:=a*0.12;
		MyList.Post;
		end;
Time1:=Time-Time1;
Write(' Created ',Del,' recs,');
DecodeTime(Time1,h,m,s,s1);
Writeln(' Time = ',h,':',m,':',s,'.',s1);
Write('Searching again ... ');
Del:=0;
Time1:=Time;
MyList.First;
for a:=1 to Count do
	if MyList.FindKey([a,a*2,a*3,a*0.12]) then Inc(Del);
Time1:=Time-Time1;
Write(' ',Del,' recs found,');
DecodeTime(Time1,h,m,s,s1);
Writeln(' Time = ',h,':',m,':',s,'.',s1);
MyList.Destroy;
ReadLn;
end.
